<template>
    <div :class="['accordion--el', {'open': isOpened}]">
        <button class="accordion--el--header" @click="toggle">
            <slot name="title"><span v-html="title"></span></slot>
            <span class="accordion--el--header--arrow"><slot name="arrow">></slot></span>
        </button>

        <div class="accordion--el--body">
            <slot name="content"><div v-html="content"></div></slot>
        </div>
    </div>
</template>

<script>
export default {
    name: 'cp-accordion-el',
    props: {
        content: String,
        open: {
            default: false,
            type: Boolean,
        },
        title: String,
    },
    data() {
        return {
            isOpened: null,
            height: null,
        };
    },
    watch: {
        open(value) {
            this.isOpened = value;
        },
        isOpened(value) {
            if(value === true) {
                //console.log('heightAuto', this.height);
                this.$el.querySelector('.accordion--el--body').style.maxHeight = this.height + 'px';
            } else {
                //console.log('height0');
                this.$el.querySelector('.accordion--el--body').style.maxHeight = 0;
            }
        }
    },
    methods: {
        toggle() {
            this.isOpened = !this.isOpened;
            this.$parent.$emit('toggle', this.isOpened, this._uid);
        },
    },
    mounted() {
        this.isOpened = this.open;
        this.height = this.$el.querySelector('.accordion--el--body > div').offsetHeight;

        this.$parent.$on('toggle', (isOpened, uid) => {
            //console.log('->', isOpened, uid);
            if (this.$parent.toggle && uid !== this._uid) {
                this.isOpened = false;
            }
        });
    },
};
</script>

<style lang="scss">
    .accordion {

        &--el {

            &--header {
                text-transform: uppercase;
                text-align: left;
                width: 100%;
                border: none;
                background-color: transparent;
                padding: 0;

                &--arrow {
                    display: inline-block;
                    transform: rotate();
                    transform-origin: center;
                    transition: .2s all ease-in;
                    margin-left: 10px;

                    /*&:after {
                        content: ">";
                        display: block;
                    }*/
                }
            }
            &--body {
                transition: .2s all ease-in;
                overflow: hidden;

                >div {
                    padding: 15px 0 30px 0;
                    border: 1px solid transparent;
                }
            }

            &.open {
                .accordion--el--header {

                    &--arrow {
                        transform: rotate(90deg);
                    }
                }
                .accordion--el--body {

                }
            }
        }
    }

</style>
